#!/bin/bash
# ***** BEGIN LICENSE BLOCK *****
# Version: MPL 1.1/GPL 2.0/LGPL 2.1
#
# The contents of this file are subject to the Mozilla Public License Version
# 1.1 (the "License"); you may not use this file except in compliance with
# the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS" basis,
# WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
# for the specific language governing rights and limitations under the
# License.
#
# The Original Code is ZINC.
#
# The Initial Developer of the Original Code is Carey Stevens.
#
# Portions created by the Initial Developer are Copyright (C) 2004
# the Initial Developer. All Rights Reserved.
#
# Contributor(s):
#
# Alternatively, the contents of this file may be used under the terms of
# either the GNU General Public License Version 2 or later (the "GPL"), or
# the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
# in which case the provisions of the GPL or the LGPL are applicable instead
# of those above. If you wish to allow use of your version of this file only
# under the terms of either the GPL or the LGPL, and not to allow others to
# use your version of this file under the terms of the MPL, indicate your
# decision by deleting the provisions above and replace them with the notice
# and other provisions required by the GPL or the LGPL. If you do not delete
# the provisions above, a recipient may use your version of this file under
# the terms of any one of the MPL, the GPL or the LGPL.
#
# ***** END LICENSE BLOCK *****


APP_NAME=mozCellML
TMP_DIR=build.tmp

rm install/$APP_NAME.xpi
rm -rf $TMP_DIR

BIN_DIR=$TMP_DIR/$APP_NAME

# create xpi directory layout
mkdir $TMP_DIR
mkdir $BIN_DIR
mkdir $BIN_DIR/chrome
mkdir $BIN_DIR/components
mkdir $BIN_DIR/runtime
# mkdir $BIN_DIR/defaults
# mkdir $BIN_DIR/defaults/preferences

# populate the xpi directory layout
# cp defaults/* $TMP_DIR/defaults
# cp defaults/preferences/* $TMP_DIR/defaults/preferences
cp components/$APP_NAME/base/src/DoIntegration.c $BIN_DIR/runtime
cp components/$APP_NAME/base/src/IntegrationHelpers.c $BIN_DIR/runtime
cp components/$APP_NAME/base/src/IntegratorCommand.h $BIN_DIR/runtime
cp components/$APP_NAME/base/public/_xpidlgen/*.xpt $BIN_DIR/components
if test -a "components/$APP_NAME/build/src/libmozCellML.so"; then
  cp components/$APP_NAME/build/src/libmozCellML.so $BIN_DIR/components
fi
if test -a "components/$APP_NAME/build/src/mozCellML.dll"; then
  cp components/$APP_NAME/build/src/mozCellML.dll $BIN_DIR/components
fi


# generate the jar file...
JARCONTENTS=`find content locale skin -path '*CVS*' -prune -o -type f -print | grep -v \~`

zip -r $BIN_DIR/chrome/$APP_NAME.jar $JARCONTENTS
cp install/install.js $TMP_DIR

# generate the XPI file
cd $TMP_DIR
zip -r ../install/$APP_NAME.xpi `find . -path './*CVS*' -prune -o -type f -print | grep -v \~`
cd ..

rm -rf $TMP_DIR
