initInstall("mozCellML", "mozcellml", "0.0.0.1");

regName = "/physiome.org/mozCellML/mozCellML";

chromeDir = getFolder("Chrome");
addFile(regName, "mozCellML/chrome/mozCellML.jar", chromeDir, null);

compDir = getFolder("Components");
try
{
  addFile(regName, "mozCellML/components/libmozCellML.so", compDir,
          null);
}
catch(e)
{
}
try
{
  addFile(regName, "mozCellML/components/mozCellML.dll", compDir,
          null);
}
catch(e)
{
}
resetError();
addFile(regName, "mozCellML/components/mozICellML.xpt", compDir,
        null);
addFile(regName, "mozCellML/components/mozCellMLIIntegrator.xpt", compDir,
        null);
addFile(regName, "mozCellML/components/mozCellMLIVariable.xpt", compDir,
        null);
addFile(regName, "mozCellML/components/mozCellMLIPointWatcher.xpt", compDir,
        null);
// This isn't a very natural place for this, but I don't know where
// else we could put it, where we will have write privileges...
addFile(regName, "mozCellML/runtime/DoIntegration.c", compDir, null);
addFile(regName, "mozCellML/runtime/IntegrationHelpers.c", compDir, null);
addFile(regName, "mozCellML/runtime/IntegratorCommand.h", compDir, null);

var file = getFolder("Chrome", "mozCellML.jar");
registerChrome(CONTENT | DELAYED_CHROME, file, "content/mozCellML/");
registerChrome(LOCALE | DELAYED_CHROME, file, "locale/en-US/mozCellML/");
registerChrome(SKIN | DELAYED_CHROME, file, "skin/mozCellML/");

var err = getLastError();

if (err == 0)
  performInstall();
else
  cancelInstall();

err = getLastError();

switch (err)
{
case SUCCESS:
case REBOOT_NEEDED:
  alert("mozCellML has been installed. Please restart Mozilla.");
  break;
case BAD_PACKAGE_NAME:
  alert("Bad package name.");
  break;
case ACCESS_DENIED:
  alert("Access denied(security error).");
  break;
//case TOO_MANY_CERTIFICATES:
//  alert("Too many certificates.");
//  break;
case NO_INSTALL_SCRIPT:
  alert("No install script.");
  break;
//case NO_CERTIFICATE:
//  alert("No certificate.");
//  break;
//case NO_MATCHING_CERTIFICATE:
//  alert("Certificate mismatch.");
//  break;
case CANT_READ_ARCHIVE:
  alert("XPI package can't be read.");
  break;
case INVALID_ARGUMENTS:
  alert("Invalid arguments.");
  break;
//case ILLEGAL_RELATIVE_PATH:
//  alert("Illegal relative path.");
//  break;
case USER_CANCELLED:
  alert("You cancelled the install.");
  break;
case INSTALL_NOT_STARTED:
  alert("Install not started");
  break;
//case SILENT_MODE_DENIED:
//  alert("Silent installation failed.");
//  break;
case NO_SUCH_COMPONENT:
  alert("No such component.");
  break;
case DOES_NOT_EXIST:
  alert("File access error. Try again as root, or install mozilla as " +
        "your user.");
  break;
case READ_ONLY:
  alert("You have read only access to your mozilla installation. Try " +
        "again as root, or install mozilla as your user.");
   break;
case IS_DIRECTORY:
  alert("Attempt to use directory.");
  break;
case NETWORK_FILE_IS_IN_USE:
  alert("File in use.");
  break;
case APPLE_SINGLE_ERR:
  alert("AppleSingle format error");
  break;
case INVALID_PATH_ERR:
  alert("Invalid path error.");
  break;
case PATCH_BAD_DIFF:
  alert("Invalid patch.");
  break;
case PATCH_BAD_CHECKSUM_TARGET:
  alert("Checksum mismatch.");
  break;
case PATCH_BAD_CHECKSUM_RESULT:
  alert("Bad checksum result.");
  break;
case UNINSTALL_FAILED:
  alert("Uninstall failed.");
  break;
case PACKAGE_FOLDER_NOT_SET:
  alert("Package folder not set.");
  break;
case EXTRACTION_FAILED:
  alert("Extraction of XPI file failed.");
  break;
case FILENAME_ALREADY_USED:
  alert("Filename was being reused.");
  break;
case INSTALL_CANCELLED:
  alert("Installation is cancelled.");
  break;
case DOWNLOAD_ERROR:
  alert("Download error");
  break;
case SCRIPT_ERROR:
  alert("Script error");
  break;
case ALREADY_EXISTS:
  alert("File already exists!");
  break;
case IS_FILE:
  alert("Trying to put a file in a file instead of directory");
  break;
case SOURCE_DOES_NOT_EXIST:
  alert("Source does not exist");
  break;
case SOURCE_IS_DIRECTORY:
  alert("Source file is a directory");
  break;
case SOURCE_IS_FILE:
  alert("Source directory is a file");
  break;
case INSUFFICIENT_DISK_SPACE:
  alert("Sorry, your disk is full. Delete some files to free up space.");
  break;
case FILENAME_TOO_LONG:
  alert("Filename is too long.");
  break;
case UNABLE_TO_LOCATE_LIB_FUNCTION:
  alert("Unable to locate library function.");
  break;
case UNABLE_TO_LOAD_LIBRARY:
  alert("Unable to load library.");
  break;                                                                                                                                                            
case CHROME_REGISTRY_ERROR:
  alert("Chrome registry error");
  break;
case MALFORMED_INSTALL:
  alert("Malformed install.");
  break;
case OUT_OF_MEMORY:
  alert("You don't have enough free memory to install. Try closing other " +
        "programs first.");
  break;
case -201:
default:
  alert("Unrecognised error.");
  break;
}
